IOobject pidDictIO
(
    "PIDInletVelocityDict",
    runTime.system(),
    runTime,
    IOobject::MUST_READ,
    IOobject::NO_WRITE,
    false
);
IOdictionary pidDict(pidDictIO);

word tPIDPatch(pidDict.lookup("patch"));
PIDPatch = tPIDPatch;

// Control variable
word tCGName(pidDict.lookup("CGName"));
CGName = tCGName;

// Reference variable
CGTgt.value() = pidDict.lookupOrDefault<vector>("targetPosition", Zero);

// PID coefficients
inletKP.value() = pidDict.lookupOrDefault<vector>("kP", Zero);
inletKI.value() = pidDict.lookupOrDefault<vector>("kI", Zero);
inletKD.value() = pidDict.lookupOrDefault<vector>("kD", Zero);

// Latest information for seamless restart
deviationOld.value() =
    pidDict.lookupOrDefault<vector>("deviationOld", Zero);
uISum.value() = pidDict.lookupOrDefault<vector>("uISum", Zero);

// Moving average of recent values of control variable
nCGList = pidDict.lookupOrDefault("movingAverageLength", 1);
CGs.setSize(nCGList, Zero);

Info<< nl
    << "PID controller coefficients for patch '" << PIDPatch << "'" << nl
    << "  targetPosition\t= " << CGTgt.value() << nl
    << "  kP\t\t\t= " << inletKP.value() << nl
    << "  kI\t\t\t= " << inletKI.value() << nl
    << "  kD\t\t\t= " << inletKD.value() << nl
    << "  deviationOld\t\t= " << deviationOld.value() << nl
    << "  uISum\t\t\t= " << uISum.value() << nl
    << "  movingAverageLength\t= " << nCGList << endl;

// Initially execute function objects
runTime.functionObjects().execute();