IOobject pidDictIO
(
    "PIDInletVelocityDict",
    runTime.system(),
    runTime,
    IOobject::MUST_READ,
    IOobject::NO_WRITE,
    false
);
IOdictionary pidDict(pidDictIO);

// Update the PID controller coefficients, if they have changed
const vector tCGTgt(pidDict.lookup("targetPosition"));
const vector tInletKP(pidDict.lookupOrDefault<vector>("kP", Zero));
const vector tInletKI(pidDict.lookupOrDefault<vector>("kI", Zero));
const vector tInletKD(pidDict.lookupOrDefault<vector>("kD", Zero));

bool changedPIDcoeffs = false;

if (CGTgt.value() != tCGTgt)
{
    CGTgt.value() = tCGTgt;
    changedPIDcoeffs = true;
}

if (inletKP.value() != tInletKP)
{
    inletKP.value() = tInletKP;
    changedPIDcoeffs = true;
}

if (inletKI.value() != tInletKI)
{
    inletKI.value() = tInletKI;
    changedPIDcoeffs = true;
}

if (inletKD.value() != tInletKD)
{
    inletKD.value() = tInletKD;
    changedPIDcoeffs = true;
}

if (changedPIDcoeffs)
{
    Info<< "  Changed PID controller coefficients:" << endl;
    Info<< "    targetPosition= " << CGTgt.value() << nl << endl;
    Info<< "    kP\t\t= " << inletKP.value() << endl;
    Info<< "    kI\t\t= " << inletKI.value() << endl;
    Info<< "    kD\t\t= " << inletKD.value() << nl << endl;
}
